Index: lemon/maps.h
===================================================================
--- lemon/maps.h	(revision 956)
+++ lemon/maps.h	(revision 314)
@@ -3,5 +3,5 @@
  * This file is a part of LEMON, a generic C++ optimization library.
  *
- * Copyright (C) 2003-2010
+ * Copyright (C) 2003-2008
  * Egervary Jeno Kombinatorikus Optimalizalasi Kutatocsoport
  * (Egervary Research Group on Combinatorial Optimization, EGRES).
@@ -23,5 +23,4 @@
 #include <functional>
 #include <vector>
-#include <map>
 
 #include <lemon/core.h>
@@ -30,4 +29,6 @@
 ///\ingroup maps
 ///\brief Miscellaneous property maps
+
+#include <map>
 
 namespace lemon {
@@ -57,5 +58,5 @@
   /// but data written to it is not required (i.e. it will be sent to
   /// <tt>/dev/null</tt>).
-  /// It conforms to the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
+  /// It conforms the \ref concepts::ReadWriteMap "ReadWriteMap" concept.
   ///
   /// \sa ConstMap
@@ -63,8 +64,7 @@
   class NullMap : public MapBase<K, V> {
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<K, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Gives back a default constructed element.
@@ -90,5 +90,5 @@
   ///
   /// In other aspects it is equivalent to \c NullMap.
-  /// So it conforms to the \ref concepts::ReadWriteMap "ReadWriteMap"
+  /// So it conforms the \ref concepts::ReadWriteMap "ReadWriteMap"
   /// concept, but it absorbs the data written to it.
   ///
@@ -103,8 +103,7 @@
     V _value;
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<K, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Default constructor
@@ -159,5 +158,5 @@
   ///
   /// In other aspects it is equivalent to \c NullMap.
-  /// So it conforms to the \ref concepts::ReadWriteMap "ReadWriteMap"
+  /// So it conforms the \ref concepts::ReadWriteMap "ReadWriteMap"
   /// concept, but it absorbs the data written to it.
   ///
@@ -170,8 +169,7 @@
   class ConstMap<K, Const<V, v> > : public MapBase<K, V> {
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<K, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor.
@@ -205,8 +203,7 @@
   class IdentityMap : public MapBase<T, T> {
   public:
-    ///\e
-    typedef T Key;
-    ///\e
-    typedef T Value;
+    typedef MapBase<T, T> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Gives back the given value without any modification.
@@ -231,7 +228,7 @@
   /// This map is essentially a wrapper for \c std::vector. It assigns
   /// values to integer keys from the range <tt>[0..size-1]</tt>.
-  /// It can be used together with some data structures, e.g.
-  /// heap types and \c UnionFind, when the used items are small
-  /// integers. This map conforms to the \ref concepts::ReferenceMap
+  /// It can be used with some data structures, for example
+  /// \c UnionFind, \c BinHeap, when the used items are small
+  /// integers. This map conforms the \ref concepts::ReferenceMap
   /// "ReferenceMap" concept.
   ///
@@ -249,8 +246,9 @@
   public:
 
+    typedef MapBase<int, V> Parent;
     /// Key type
-    typedef int Key;
+    typedef typename Parent::Key Key;
     /// Value type
-    typedef V Value;
+    typedef typename Parent::Value Value;
     /// Reference type
     typedef typename Vector::reference Reference;
@@ -341,5 +339,5 @@
   /// stored actually. This value can be different from the default
   /// contructed value (i.e. \c %Value()).
-  /// This type conforms to the \ref concepts::ReferenceMap "ReferenceMap"
+  /// This type conforms the \ref concepts::ReferenceMap "ReferenceMap"
   /// concept.
   ///
@@ -349,12 +347,12 @@
   /// The name of this type also refers to this important usage.
   ///
-  /// Apart form that, this map can be used in many other cases since it
+  /// Apart form that this map can be used in many other cases since it
   /// is based on \c std::map, which is a general associative container.
-  /// However, keep in mind that it is usually not as efficient as other
+  /// However keep in mind that it is usually not as efficient as other
   /// maps.
   ///
   /// The simplest way of using this map is through the sparseMap()
   /// function.
-  template <typename K, typename V, typename Comp = std::less<K> >
+  template <typename K, typename V, typename Compare = std::less<K> >
   class SparseMap : public MapBase<K, V> {
     template <typename K1, typename V1, typename C1>
@@ -362,8 +360,9 @@
   public:
 
+    typedef MapBase<K, V> Parent;
     /// Key type
-    typedef K Key;
+    typedef typename Parent::Key Key;
     /// Value type
-    typedef V Value;
+    typedef typename Parent::Value Value;
     /// Reference type
     typedef Value& Reference;
@@ -375,5 +374,5 @@
   private:
 
-    typedef std::map<K, V, Comp> Map;
+    typedef std::map<K, V, Compare> Map;
     Map _map;
     Value _value;
@@ -491,13 +490,12 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M2::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M2::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     ComposeMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
 
-    ///\e
+    /// \e
     typename MapTraits<M1>::ConstReturnValue
     operator[](const Key &k) const { return _m1[_m2[k]]; }
@@ -548,13 +546,12 @@
     F _f;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<typename M1::Key, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     CombineMap(const M1 &m1, const M2 &m2, const F &f = F())
       : _m1(m1), _m2(m2), _f(f) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _f(_m1[k],_m2[k]); }
   };
@@ -619,12 +616,11 @@
     F _f;
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<K, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     FunctorToMap(const F &f = F()) : _f(f) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _f(k); }
   };
@@ -674,17 +670,16 @@
     const M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
-
-    typedef typename M::Key argument_type;
-    typedef typename M::Value result_type;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
+
+    typedef typename Parent::Key argument_type;
+    typedef typename Parent::Value result_type;
 
     /// Constructor
     MapToFunctor(const M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator()(const Key &k) const { return _m[k]; }
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m[k]; }
   };
@@ -707,5 +702,5 @@
   /// The \c Key type of it is inherited from \c M and the \c Value
   /// type is \c V.
-  /// This type conforms to the \ref concepts::ReadMap "ReadMap" concept.
+  /// This type conforms the \ref concepts::ReadMap "ReadMap" concept.
   ///
   /// The simplest way of using this map is through the convertMap()
@@ -715,8 +710,7 @@
     const M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef V Value;
+    typedef MapBase<typename M::Key, V> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -726,5 +720,5 @@
     ConvertMap(const M &m) : _m(m) {}
 
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m[k]; }
   };
@@ -758,8 +752,7 @@
     M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M1::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -805,12 +798,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M1::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     AddMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]+_m2[k]; }
   };
@@ -854,12 +846,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M1::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     SubMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]-_m2[k]; }
   };
@@ -904,12 +895,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M1::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     MulMap(const M1 &m1,const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]*_m2[k]; }
   };
@@ -953,12 +943,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef typename M1::Value Value;
+    typedef MapBase<typename M1::Key, typename M1::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     DivMap(const M1 &m1,const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]/_m2[k]; }
   };
@@ -1004,8 +993,7 @@
     C _v;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -1015,5 +1003,5 @@
     /// \param v The constant value.
     ShiftMap(const M &m, const C &v) : _m(m), _v(v) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m[k]+_v; }
   };
@@ -1035,8 +1023,7 @@
     C _v;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -1046,7 +1033,7 @@
     /// \param v The constant value.
     ShiftWriteMap(M &m, const C &v) : _m(m), _v(v) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m[k]+_v; }
-    ///\e
+    /// \e
     void set(const Key &k, const Value &v) { _m.set(k, v-_v); }
   };
@@ -1107,8 +1094,7 @@
     C _v;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -1118,5 +1104,5 @@
     /// \param v The constant value.
     ScaleMap(const M &m, const C &v) : _m(m), _v(v) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _v*_m[k]; }
   };
@@ -1139,8 +1125,7 @@
     C _v;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
@@ -1150,7 +1135,7 @@
     /// \param v The constant value.
     ScaleWriteMap(M &m, const C &v) : _m(m), _v(v) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _v*_m[k]; }
-    ///\e
+    /// \e
     void set(const Key &k, const Value &v) { _m.set(k, v/_v); }
   };
@@ -1209,12 +1194,11 @@
     const M& _m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     NegMap(const M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return -_m[k]; }
   };
@@ -1245,14 +1229,13 @@
     M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     NegWriteMap(M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return -_m[k]; }
-    ///\e
+    /// \e
     void set(const Key &k, const Value &v) { _m.set(k, -v); }
   };
@@ -1300,12 +1283,11 @@
     const M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef typename M::Value Value;
+    typedef MapBase<typename M::Key, typename M::Value> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     AbsMap(const M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const {
       Value tmp = _m[k];
@@ -1356,8 +1338,7 @@
   class TrueMap : public MapBase<K, bool> {
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<K, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Gives back \c true.
@@ -1394,8 +1375,7 @@
   class FalseMap : public MapBase<K, bool> {
   public:
-    ///\e
-    typedef K Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<K, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Gives back \c false.
@@ -1440,12 +1420,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M1::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     AndMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]&&_m2[k]; }
   };
@@ -1489,12 +1468,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M1::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     OrMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]||_m2[k]; }
   };
@@ -1529,12 +1507,11 @@
     const M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     NotMap(const M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return !_m[k]; }
   };
@@ -1556,14 +1533,13 @@
     M &_m;
   public:
-    ///\e
-    typedef typename M::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     NotWriteMap(M &m) : _m(m) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return !_m[k]; }
-    ///\e
+    /// \e
     void set(const Key &k, bool v) { _m.set(k, !v); }
   };
@@ -1620,12 +1596,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M1::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     EqualMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]==_m2[k]; }
   };
@@ -1669,12 +1644,11 @@
     const M2 &_m2;
   public:
-    ///\e
-    typedef typename M1::Key Key;
-    ///\e
-    typedef bool Value;
+    typedef MapBase<typename M1::Key, bool> Parent;
+    typedef typename Parent::Key Key;
+    typedef typename Parent::Value Value;
 
     /// Constructor
     LessMap(const M1 &m1, const M2 &m2) : _m1(m1), _m2(m2) {}
-    ///\e
+    /// \e
     Value operator[](const Key &k) const { return _m1[k]<_m2[k]; }
   };
@@ -1732,6 +1706,6 @@
   /// function.
   ///
-  /// \tparam IT The type of the iterator.
-  /// \tparam KEY The key type of the map. The default value set
+  /// \tparam It The type of the iterator.
+  /// \tparam Ke The key type of the map. The default value set
   /// according to the iterator type should work in most cases.
   ///
@@ -1739,18 +1713,15 @@
   /// for the elements or the iterator should be an inserter iterator.
 #ifdef DOXYGEN
-  template <typename IT, typename KEY>
+  template <typename It, typename Ke>
 #else
-  template <typename IT,
-            typename KEY = typename _maps_bits::IteratorTraits<IT>::Value>
+  template <typename It,
+            typename Ke=typename _maps_bits::IteratorTraits<It>::Value>
 #endif
-  class LoggerBoolMap : public MapBase<KEY, bool> {
-  public:
-
-    ///\e
-    typedef KEY Key;
-    ///\e
+  class LoggerBoolMap {
+  public:
+    typedef It Iterator;
+
+    typedef Ke Key;
     typedef bool Value;
-    ///\e
-    typedef IT Iterator;
 
     /// Constructor
@@ -1786,13 +1757,13 @@
   /// The most important usage of it is storing certain nodes or arcs
   /// that were marked \c true by an algorithm.
-  /// For example, it makes easier to store the nodes in the processing
+  /// For example it makes easier to store the nodes in the processing
   /// order of Dfs algorithm, as the following examples show.
   /// \code
   ///   std::vector<Node> v;
-  ///   dfs(g).processedMap(loggerBoolMap(std::back_inserter(v))).run(s);
+  ///   dfs(g,s).processedMap(loggerBoolMap(std::back_inserter(v))).run();
   /// \endcode
   /// \code
   ///   std::vector<Node> v(countNodes(g));
-  ///   dfs(g).processedMap(loggerBoolMap(v.begin())).run(s);
+  ///   dfs(g,s).processedMap(loggerBoolMap(v.begin())).run();
   /// \endcode
   ///
@@ -1801,5 +1772,5 @@
   ///
   /// \note LoggerBoolMap is just \ref concepts::WriteMap "writable", so
-  /// it cannot be used when a readable map is needed, for example, as
+  /// it cannot be used when a readable map is needed, for example as
   /// \c ReachedMap for \c Bfs, \c Dfs and \c Dijkstra algorithms.
   ///
@@ -1815,34 +1786,21 @@
   /// @{
 
-  /// \brief Provides an immutable and unique id for each item in a graph.
-  ///
-  /// IdMap provides a unique and immutable id for each item of the
-  /// same type (\c Node, \c Arc or \c Edge) in a graph. This id is
-  ///  - \b unique: different items get different ids,
-  ///  - \b immutable: the id of an item does not change (even if you
-  ///    delete other nodes).
-  ///
-  /// Using this map you get access (i.e. can read) the inner id values of
-  /// the items stored in the graph, which is returned by the \c id()
-  /// function of the graph. This map can be inverted with its member
-  /// class \c InverseMap or with the \c operator()() member.
-  ///
-  /// \tparam GR The graph type.
-  /// \tparam K The key type of the map (\c GR::Node, \c GR::Arc or
-  /// \c GR::Edge).
-  ///
-  /// \see RangeIdMap
-  template <typename GR, typename K>
-  class IdMap : public MapBase<K, int> {
-  public:
-    /// The graph type of IdMap.
-    typedef GR Graph;
-    typedef GR Digraph;
-    /// The key type of IdMap (\c Node, \c Arc or \c Edge).
-    typedef K Item;
-    /// The key type of IdMap (\c Node, \c Arc or \c Edge).
-    typedef K Key;
-    /// The value type of IdMap.
+  /// Provides an immutable and unique id for each item in the graph.
+
+  /// The IdMap class provides a unique and immutable id for each item of the
+  /// same type (e.g. node) in the graph. This id is <ul><li>\b unique:
+  /// different items (nodes) get different ids <li>\b immutable: the id of an
+  /// item (node) does not change (even if you delete other nodes).  </ul>
+  /// Through this map you get access (i.e. can read) the inner id values of
+  /// the items stored in the graph. This map can be inverted with its member
+  /// class \c InverseMap or with the \c operator() member.
+  ///
+  template <typename _Graph, typename _Item>
+  class IdMap {
+  public:
+    typedef _Graph Graph;
     typedef int Value;
+    typedef _Item Item;
+    typedef _Item Key;
 
     /// \brief Constructor.
@@ -1856,7 +1814,7 @@
     int operator[](const Item& item) const { return _graph->id(item);}
 
-    /// \brief Gives back the \e item by its id.
-    ///
-    /// Gives back the \e item by its id.
+    /// \brief Gives back the item by its id.
+    ///
+    /// Gives back the item by its id.
     Item operator()(int id) { return _graph->fromId(id, Item()); }
 
@@ -1866,9 +1824,7 @@
   public:
 
-    /// \brief The inverse map type of IdMap.
-    ///
-    /// The inverse map type of IdMap. The subscript operator gives back
-    /// an item by its id.
-    /// This type conforms to the \ref concepts::ReadMap "ReadMap" concept.
+    /// \brief The class represents the inverse of its owner (IdMap).
+    ///
+    /// The class represents the inverse of its owner (IdMap).
     /// \see inverse()
     class InverseMap {
@@ -1885,7 +1841,8 @@
       explicit InverseMap(const IdMap& map) : _graph(map._graph) {}
 
-      /// \brief Gives back an item by its id.
+      /// \brief Gives back the given item from its id.
       ///
-      /// Gives back an item by its id.
+      /// Gives back the given item from its id.
+      ///
       Item operator[](int id) const { return _graph->fromId(id, Item());}
 
@@ -1898,105 +1855,76 @@
     /// Gives back the inverse of the IdMap.
     InverseMap inverse() const { return InverseMap(*_graph);}
-  };
-
-  /// \brief Returns an \c IdMap class.
-  ///
-  /// This function just returns an \c IdMap class.
-  /// \relates IdMap
-  template <typename K, typename GR>
-  inline IdMap<GR, K> idMap(const GR& graph) {
-    return IdMap<GR, K>(graph);
-  }
-
-  /// \brief General cross reference graph map type.
-
-  /// This class provides simple invertable graph maps.
-  /// It wraps a standard graph map (\c NodeMap, \c ArcMap or \c EdgeMap)
-  /// and if a key is set to a new value, then stores it in the inverse map.
-  /// The graph items can be accessed by their values either using
-  /// \c InverseMap or \c operator()(), and the values of the map can be
-  /// accessed with an STL compatible forward iterator (\c ValueIt).
-  ///
-  /// This map is intended to be used when all associated values are
-  /// different (the map is actually invertable) or there are only a few
-  /// items with the same value.
-  /// Otherwise consider to use \c IterableValueMap, which is more
-  /// suitable and more efficient for such cases. It provides iterators
-  /// to traverse the items with the same associated value, but
-  /// it does not have \c InverseMap.
-  ///
-  /// This type is not reference map, so it cannot be modified with
-  /// the subscript operator.
-  ///
-  /// \tparam GR The graph type.
-  /// \tparam K The key type of the map (\c GR::Node, \c GR::Arc or
-  /// \c GR::Edge).
-  /// \tparam V The value type of the map.
+
+  };
+
+
+  /// \brief General invertable graph-map type.
+
+  /// This type provides simple invertable graph-maps.
+  /// The InvertableMap wraps an arbitrary ReadWriteMap
+  /// and if a key is set to a new value then store it
+  /// in the inverse map.
+  ///
+  /// The values of the map can be accessed
+  /// with stl compatible forward iterator.
+  ///
+  /// \tparam _Graph The graph type.
+  /// \tparam _Item The item type of the graph.
+  /// \tparam _Value The value type of the map.
   ///
   /// \see IterableValueMap
-  template <typename GR, typename K, typename V>
-  class CrossRefMap
-    : protected ItemSetTraits<GR, K>::template Map<V>::Type {
+  template <typename _Graph, typename _Item, typename _Value>
+  class InvertableMap
+    : protected ItemSetTraits<_Graph, _Item>::template Map<_Value>::Type {
   private:
 
-    typedef typename ItemSetTraits<GR, K>::
-      template Map<V>::Type Map;
-
-    typedef std::multimap<V, K> Container;
+    typedef typename ItemSetTraits<_Graph, _Item>::
+    template Map<_Value>::Type Map;
+    typedef _Graph Graph;
+
+    typedef std::map<_Value, _Item> Container;
     Container _inv_map;
 
   public:
 
-    /// The graph type of CrossRefMap.
-    typedef GR Graph;
-    typedef GR Digraph;
-    /// The key type of CrossRefMap (\c Node, \c Arc or \c Edge).
-    typedef K Item;
-    /// The key type of CrossRefMap (\c Node, \c Arc or \c Edge).
-    typedef K Key;
-    /// The value type of CrossRefMap.
-    typedef V Value;
+    /// The key type of InvertableMap (Node, Arc, Edge).
+    typedef typename Map::Key Key;
+    /// The value type of the InvertableMap.
+    typedef typename Map::Value Value;
 
     /// \brief Constructor.
     ///
-    /// Construct a new CrossRefMap for the given graph.
-    explicit CrossRefMap(const Graph& graph) : Map(graph) {}
+    /// Construct a new InvertableMap for the graph.
+    ///
+    explicit InvertableMap(const Graph& graph) : Map(graph) {}
 
     /// \brief Forward iterator for values.
     ///
-    /// This iterator is an STL compatible forward
+    /// This iterator is an stl compatible forward
     /// iterator on the values of the map. The values can
-    /// be accessed in the <tt>[beginValue, endValue)</tt> range.
-    /// They are considered with multiplicity, so each value is
-    /// traversed for each item it is assigned to.
-    class ValueIt
+    /// be accessed in the [beginValue, endValue) range.
+    ///
+    class ValueIterator
       : public std::iterator<std::forward_iterator_tag, Value> {
-      friend class CrossRefMap;
+      friend class InvertableMap;
     private:
-      ValueIt(typename Container::const_iterator _it)
+      ValueIterator(typename Container::const_iterator _it)
         : it(_it) {}
     public:
 
-      /// Constructor
-      ValueIt() {}
-
-      /// \e
-      ValueIt& operator++() { ++it; return *this; }
-      /// \e
-      ValueIt operator++(int) {
-        ValueIt tmp(*this);
+      ValueIterator() {}
+
+      ValueIterator& operator++() { ++it; return *this; }
+      ValueIterator operator++(int) {
+        ValueIterator tmp(*this);
         operator++();
         return tmp;
       }
 
-      /// \e
       const Value& operator*() const { return it->first; }
-      /// \e
       const Value* operator->() const { return &(it->first); }
 
-      /// \e
-      bool operator==(ValueIt jt) const { return it == jt.it; }
-      /// \e
-      bool operator!=(ValueIt jt) const { return it != jt.it; }
+      bool operator==(ValueIterator jt) const { return it == jt.it; }
+      bool operator!=(ValueIterator jt) const { return it != jt.it; }
 
     private:
@@ -2004,47 +1932,40 @@
     };
 
-    /// Alias for \c ValueIt
-    typedef ValueIt ValueIterator;
-
     /// \brief Returns an iterator to the first value.
     ///
-    /// Returns an STL compatible iterator to the
+    /// Returns an stl compatible iterator to the
     /// first value of the map. The values of the
-    /// map can be accessed in the <tt>[beginValue, endValue)</tt>
+    /// map can be accessed in the [beginValue, endValue)
     /// range.
-    ValueIt beginValue() const {
-      return ValueIt(_inv_map.begin());
+    ValueIterator beginValue() const {
+      return ValueIterator(_inv_map.begin());
     }
 
     /// \brief Returns an iterator after the last value.
     ///
-    /// Returns an STL compatible iterator after the
+    /// Returns an stl compatible iterator after the
     /// last value of the map. The values of the
-    /// map can be accessed in the <tt>[beginValue, endValue)</tt>
+    /// map can be accessed in the [beginValue, endValue)
     /// range.
-    ValueIt endValue() const {
-      return ValueIt(_inv_map.end());
-    }
-
-    /// \brief Sets the value associated with the given key.
-    ///
-    /// Sets the value associated with the given key.
+    ValueIterator endValue() const {
+      return ValueIterator(_inv_map.end());
+    }
+
+    /// \brief The setter function of the map.
+    ///
+    /// Sets the mapped value.
     void set(const Key& key, const Value& val) {
       Value oldval = Map::operator[](key);
-      typename Container::iterator it;
-      for (it = _inv_map.equal_range(oldval).first;
-           it != _inv_map.equal_range(oldval).second; ++it) {
-        if (it->second == key) {
-          _inv_map.erase(it);
-          break;
-        }
+      typename Container::iterator it = _inv_map.find(oldval);
+      if (it != _inv_map.end() && it->second == key) {
+        _inv_map.erase(it);
       }
-      _inv_map.insert(std::make_pair(val, key));
+      _inv_map.insert(make_pair(val, key));
       Map::set(key, val);
     }
 
-    /// \brief Returns the value associated with the given key.
-    ///
-    /// Returns the value associated with the given key.
+    /// \brief The getter function of the map.
+    ///
+    /// It gives back the value associated with the key.
     typename MapTraits<Map>::ConstReturnValue
     operator[](const Key& key) const {
